#ifndef __TARGET_MATERIAL_H__
#define __TARGET_MATERIAL_H__

#include "FourVector/FourVector.h"
#include "Masses.h"


class TargetMaterial 
{ 
private:

public:
  TargetMaterial(double A, double Z, double I, double rho, double C, double X0, double X1, double a, double m);
  virtual ~TargetMaterial() { ; }
  /// Density in \TEX{$g/cm^3$}
  double Density;
  /// Ionisation potential in eV
  double IonisationPotential;
  /// Parameters Density Corr.
  double DC_C, DC_m, DC_x0, DC_x1, DC_a;
  /// Massnumber A
  double Massnumber;
  /// Chargenumber Z
  double Chargenumber;
};

#endif 











